//
//  SMTimeFile.h
//  Licensing
//
//  Created by Sean Kelly on 11/12/07.
//  Copyright 2007 skti. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "SMTypes.h"

typedef NSMutableDictionary SMTimeFile;

typedef enum {
	SMTimeFilePolicySection = 0,
	SMTimeFileLicenseSection,
	SMTimeFileSectionCount
} SMTimeFileSection;

SMTimeFile *SMSharedTimeFile();
NSString *SMSharedTimeFilePath();
void SMTimeFileSetSharedPath(NSString *path);

void SMTimeFileNoteFullyLicensed();

SMDateType SMDateTypeForStartDateAndDuration(NSDate *startDate, NSTimeInterval duration);

// attempts to load the time file at path.  if that fails, it does some checks for tampering.  if no tampering is detected, will create a fresh time file and write it to path.
SMTimeFile *SMTimeFileCreateWithPath(NSString *path);
void SMTimeFileRelease(SMTimeFile *timeFile);

BOOL SMTimeFileWriteToPath(SMTimeFile *timeFile, NSString *path);

NSDate *SMTimeFileGetStartDateForSection(SMTimeFile *timeFile, SMTimeFileSection section, NSString *identifier);
BOOL SMTimeFileSetStartDateForSection(SMTimeFile *timeFile, SMTimeFileSection section, NSString *identifier, NSDate *date);
