//
//  SMUnlicensedWindowController.h
//  Licensing
//
//  Created by Sean Kelly on 11/17/07.
//  Copyright 2007 skti. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <SmackUI/SMTypes.h>

@class SMUnlicensedPane, SMRecoveryPolicy, SMRecoveryWindowController;

@interface SMUnlicensedWindowController : NSWindowController {
	id _delegate;
	
	IBOutlet NSBox *_contentBox;
	
	SMLicenseState _state;
	SMUnlicensedPane *_currentPane;		// weak
	CFMutableDictionaryRef _paneForLicenseState;
	
	SMRecoveryWindowController *_recoveryController;
}

+ (void)showMissingResourcesAlert;

- (id)initWithState:(SMLicenseState)state;
- (void)setState:(SMLicenseState)state;

- (void)registerPane:(SMUnlicensedPane *)pane forLicenseState:(SMLicenseState)state;
- (void)setDelegate:(id)delegate;

- (IBAction)buyLicense:(id)sender;
- (IBAction)addLicense:(id)sender;
- (IBAction)recoverLicense:(id)sender;

@end


@interface NSObject (SMUnlicensedWindowControllerDelegate)
// optional.  if unimplemented or nil, will use the default policy.
- (SMRecoveryPolicy *)recoverPolicyForUnlicensedWindowController:(SMUnlicensedWindowController *)controller;
@end


extern void SMShowMissingResourcesModalDialog();
